package de.jottyfan.quickiemod.block;

import java.util.Arrays;
import java.util.List;
import java.util.Random;

import com.mojang.serialization.MapCodec;

import de.jottyfan.quickiemod.item.ModItems;
import net.minecraft.block.AbstractBlock;
import net.minecraft.block.BlockState;
import net.minecraft.block.Blocks;
import net.minecraft.block.FallingBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Items;
import net.minecraft.loot.context.LootWorldContext.Builder;
import net.minecraft.registry.RegistryKey;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.util.Identifier;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.BlockView;

/**
 *
 * @author jotty
 *
 */
public class BlockDirtSalpeter extends FallingBlock {

	public BlockDirtSalpeter(Identifier identifier) {
		super(AbstractBlock.Settings.create().hardness(3.1f).registryKey(RegistryKey.of(RegistryKeys.BLOCK, identifier)));
	}

	@Override
	public List<ItemStack> getDroppedStacks(BlockState blockState, Builder builder) {
		Integer count = (Double.valueOf(new Random().nextDouble() * 10).intValue() / 4) + 1;
		boolean spawnBoneMeal = new Random().nextDouble() > 0.5f;
		ItemStack boneMealStack = new ItemStack(Items.BONE_MEAL);
		ItemStack salpeterStack = new ItemStack(ModItems.ITEM_SALPETER, count);
		ItemStack dirtStack = new ItemStack(Blocks.DIRT);
		ItemStack[] spawnies = spawnBoneMeal ? new ItemStack[] { boneMealStack, salpeterStack, dirtStack }
				: new ItemStack[] { salpeterStack, dirtStack };
		return Arrays.asList(spawnies);
	}

	@Override
	protected MapCodec<? extends FallingBlock> getCodec() {
		return null;
	}

	@Override
	public int getColor(BlockState state, BlockView world, BlockPos pos) {
		return 0;
	}
}
