package de.jottyfan.quickiemod.block;

import java.util.Arrays;
import java.util.List;

import de.jottyfan.quickiemod.block.help.IntProviderHelper;
import de.jottyfan.quickiemod.item.ModItems;
import net.minecraft.block.BlockState;
import net.minecraft.block.ExperienceDroppingBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.loot.context.LootWorldContext.Builder;
import net.minecraft.registry.RegistryKey;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.sound.BlockSoundGroup;
import net.minecraft.util.Identifier;

/**
 *
 * @author jotty
 *
 */
public class BlockOreTurquoise extends ExperienceDroppingBlock {

	public BlockOreTurquoise(Identifier identifier) {
		super(IntProviderHelper.of(0, 2), Settings.create().strength(3.0f).hardness(3.5f).sounds(BlockSoundGroup.AMETHYST_BLOCK)
				.requiresTool().registryKey(RegistryKey.of(RegistryKeys.BLOCK, identifier)));
	}

	@Override
	public List<ItemStack> getDroppedStacks(BlockState state, Builder builder) {
		return Arrays.asList(new ItemStack[] { new ItemStack(ModItems.ITEM_RAWTURQUOISE) });
	}
}
